//#define _DESKTOP_

using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Runtime.InteropServices; // for using other APIs
using System.Threading;

namespace SusiDemo
{
    public partial class Form1 : Form
    {

        //===============================================================
        // Dll
        //
        [DllImport("Susi.dll")]
        public static extern int SusiDllGetLastError();
        [DllImport("Susi.dll")]
        public unsafe static extern void SusiDllGetVersion(UInt32 *major, UInt32 *minor);
        [DllImport("Susi.dll")]  
        public static extern bool SusiDllInit();
        [DllImport("Susi.dll")]  
        public static extern bool SusiDllUnInit();

        //===============================================================
        // Core (Boot Logger)
        //
        [DllImport("Susi.dll")]
        public unsafe static extern bool SusiCoreAccessBootCounter(UInt32 mode, UInt32 OPFlag, bool *enable, UInt32 *value);
        [DllImport("Susi.dll")]
        public static extern bool SusiCoreAccessRunTimer(UInt32 mode, ref SSCORE_RUNTIMER refRunTimer);
        [DllImport("Susi.dll")]
        public static extern int SusiCoreAvailable();
        [DllImport("Susi.dll")]
        public unsafe static extern int SusiCoreGetBIOSVersion(char *BIOSVersion, UInt32 *size);
        [DllImport("Susi.dll")]
        public unsafe static extern int SusiCoreGetPlatformName(char* PlatformName, UInt32 *size);

        // Old (backward-compatible)
        [DllImport("Susi.dll")]
        public unsafe static extern int SusiGetPlatformName(char *PlatformName, byte size);   
        [DllImport("Susi.dll")]
        public unsafe static extern int SusiGetBIOSVersion(char* BIOSVersion, byte size);

        //===============================================================
        // Watchdog
        //
        [DllImport("Susi.dll")]@
        public static extern int SusiWDAvailable();
        [DllImport("Susi.dll")]  
        public static extern bool SusiWDDisable();
        [DllImport("Susi.dll")]  
        public unsafe static extern bool SusiWDGetRange(UInt32 *minimum, UInt32 *maximum, UInt32 *stepping);
        [DllImport("Susi.dll")]  
        public unsafe static extern bool SusiWDSetConfig(UInt32 delay, UInt32 timeout);
        [DllImport("Susi.dll")]  
        public static extern bool SusiWDTrigger();

        //===============================================================
        // GPIO
        //
        // Common 
        [DllImport("Susi.dll")]
        public static extern int SusiIOAvailable();

        // Programmable
        [DllImport("Susi.dll")]
        public unsafe static extern bool SusiIOCountEx(UInt32 *inCount, UInt32 *outCount);
        [DllImport("Susi.dll")]
        public unsafe static extern bool SusiIOQueryMask(UInt32 flag, UInt32 *Mask);
        [DllImport("Susi.dll")]
        public unsafe static extern bool SusiIOReadEx(byte PinNum, Int32 *status);
        [DllImport("Susi.dll")]
        public unsafe static extern bool SusiIOReadMultiEx(UInt32 TargetPinMask, UInt32 *StatusMask);
        [DllImport("Susi.dll")]
        public unsafe static extern bool SusiIOSetDirection(byte PinNum, byte IO, UInt32 *PinDirMask);
        [DllImport("Susi.dll")]
        public unsafe static extern bool SusiIOSetDirectionMulti(UInt32 TargetPinMask, UInt32 *PinDirMask);
        [DllImport("Susi.dll")]
        public unsafe static extern bool SusiIOWriteEx(byte PinNum, Int32 status);
        [DllImport("Susi.dll")]
        public unsafe static extern bool SusiIOWriteMultiEx(UInt32 TargetPinMask, UInt32 StatusMask);

        // Not programmable (backward-compatible)
        [DllImport("Susi.dll")]
        public unsafe static extern bool SusiIOCount(UInt16 *inCount, UInt16 *outCount);
        [DllImport("Susi.dll")]
        public static extern bool SusiIOInitial(UInt32 statuses);        
        [DllImport("Susi.dll")]
        public unsafe static extern bool SusiIORead(byte pin, bool *status);
        [DllImport("Susi.dll")]
        public unsafe static extern bool SusiIOReadMulti(UInt32 pins, UInt32 *statuses);
        [DllImport("Susi.dll")]
        public static extern bool SusiIOWrite(byte pin, bool status);
        [DllImport("Susi.dll")]
        public static extern bool SusiIOWriteMulti(UInt32 pins, UInt32 statuses);

        //===============================================================
        // SMBus
        //
        [DllImport("Susi.dll")]
        public static extern int SusiSMBusAvailable();
        [DllImport("Susi.dll")]
        public unsafe static extern bool SusiSMBusReadBlock(byte SlaveAddress, byte RegisterOffset, byte *Result, byte *ByteCount);
        [DllImport("Susi.dll")]
        public unsafe static extern bool SusiSMBusReadByte(byte SlaveAddress, byte RegisterOffset, byte *Result);
        [DllImport("Susi.dll")]
        public static extern bool SusiSMBusReadQuick(byte SlaveAddress);
        [DllImport("Susi.dll")]
        public unsafe static extern bool SusiSMBusReadWord(byte SlaveAddress, byte RegisterOffset, UInt16 *Result);
        [DllImport("Susi.dll")]
        public unsafe static extern bool SusiSMBusReceiveByte(byte SlaveAddress, byte *Result);
        [DllImport("Susi.dll")]
        public static extern int SusiSMBusScanDevice(byte SlaveAddress_7);
        [DllImport("Susi.dll")]
        public static extern bool SusiSMBusSendByte(byte SlaveAddress, byte Result);
        [DllImport("Susi.dll")]
        public unsafe static extern bool SusiSMBusWriteBlock(byte SlaveAddress, byte RegisterOffset, byte *Result, byte ByteCount);
        [DllImport("Susi.dll")]
        public static extern bool SusiSMBusWriteByte(byte SlaveAddress, byte RegisterOffset, byte Result);
        [DllImport("Susi.dll")]
        public static extern bool SusiSMBusWriteQuick(byte SlaveAddress);
        [DllImport("Susi.dll")]
        public static extern bool SusiSMBusWriteWord(byte SlaveAddress, byte RegisterOffset, UInt16 Result);

        //===============================================================
        // IIC
        //
        [DllImport("Susi.dll")]
        public static extern int SusiIICAvailable();
        [DllImport("Susi.dll")]
        public unsafe static extern bool SusiIICRead(UInt32 IICType, byte SlaveAddress, byte* ReadBuf, UInt32 ReadLen);
        [DllImport("Susi.dll")]
        public unsafe static extern bool SusiIICWrite(UInt32 IICType, byte SlaveAddress, byte* WriteBuf, UInt32 WriteLen);
        [DllImport("Susi.dll")]
        public unsafe static extern bool SusiIICWriteReadCombine(UInt32 IICType, byte SlaveAddress, byte* WriteBuf, UInt32 WriteLen, byte* ReadBuf, UInt32 ReadLen);  
    
        // Old (backward-compatible)
        [DllImport("Susi.dll")]
        public unsafe static extern bool SusiIICReadByte(byte SlaveAddress, byte RegisterOffset, byte *Result);
        [DllImport("Susi.dll")]
        public unsafe static extern bool SusiIICReadByteMulti(byte SlaveAddress, byte *ReadBuf, UInt32 ReadLen);
        [DllImport("Susi.dll")]
        public unsafe static extern bool SusiIICWriteByte(byte SlaveAddress, byte RegisterOffset, byte Result);
        [DllImport("Susi.dll")]
        public unsafe static extern bool SusiIICWriteByteMulti(byte SlaveAddress, byte *WriteBuf, UInt32 WriteLen);

        //===============================================================
        // VGA Control
        //
        [DllImport("Susi.dll")]
        public static extern int SusiVCAvailable();
        [DllImport("Susi.dll")]
        public unsafe static extern bool SusiVCGetBright(byte *brightness);
        [DllImport("Susi.dll")]
        public unsafe static extern bool SusiVCGetBrightRange(byte *minimum, byte *maximum, byte *stepping);
        [DllImport("Susi.dll")]
        public static extern bool SusiVCScreenOff();
        [DllImport("Susi.dll")]
        public static extern bool SusiVCScreenOn();     
        [DllImport("Susi.dll")]
        public static extern bool SusiVCSetBright(byte brightness);

        //===============================================================
        // Hardware Monitor Control
        //
        [DllImport("Susi.dll")]
        public static extern int SusiHWMAvailable();
        [DllImport("Susi.dll")]
        public unsafe static extern bool SusiHWMGetFanSpeed(UInt16 fanType, UInt16* retval, UInt16 *typeSupport);
        [DllImport("Susi.dll")]
        public unsafe static extern bool SusiHWMGetTemperature(UInt16 tempType, float* retval, UInt16 *typeSupport);
        [DllImport("Susi.dll")]
        public unsafe static extern bool SusiHWMGetVoltage(UInt32 voltType, float* retval, UInt32 *typeSupport);
        [DllImport("Susi.dll")]
        public unsafe static extern bool SusiHWMSetFanSpeed(UInt16 fanType, byte setval, UInt16 *typeSupport);

        bool gisWinCE = false;
        //===============================================================
        // CORE (Boot Logger)
        //

        /****************************** 
         * Boot Counter
         *******************************/
        enum ESCORE_BOOTCOUNTER
        {
            ESCORE_BOOTCOUNTER_STATUS = 0x01,
            ESCORE_BOOTCOUNTER_VALUE = 0x02
        }

        enum ESCORE_BOOTCOUNTER_MODE
        {
            ESCORE_BOOTCOUNTER_MODE_GET = 0,
            ESCORE_BOOTCOUNTER_MODE_SET = 1
        }

        /****************************** 
         * Run Timer
         *******************************/
        enum ESCORE_RUNTIMER
        {

            ESCORE_RUNTIMER_STATUS_RUNNING = 0x01,
            ESCORE_RUNTIMER_STATUS_AUTORUN = 0x02,
            ESCORE_RUNTIMER_VALUE_CONTINUALON = 0x04,
            ESCORE_RUNTIMER_VALUE_TOTALON = 0x08
        }

        enum ESCORE_RUNTIMER_MODE
        {
            ESCORE_RUNTIMER_MODE_GET = 0,
            ESCORE_RUNTIMER_MODE_SET = 1
        }

        //[StructLayout(LayoutKind.Sequential)]
        public struct SSCORE_RUNTIMER
        {
            public UInt32 dwOPFlag;
            public Int32 isRunning;   // if define BOOL in Struct in C, remember to define it as Int32 in C#
            public Int32 isAutorun;
            public UInt32 dwTimeContinual;
            public UInt32 dwTimeTotal;
        }

        //===============================================================
        // Watchdog       
        //
        private System.Windows.Forms.Timer timerWDT = new System.Windows.Forms.Timer();
        private int iTimerCountDownWDT, iTimeOutWDT;
        private const int timerIntervalWDT = 100;		
		private DateTime WDTTimeStamp ;


        //===============================================================
        // GPIO       
        //
        enum ESIO_MASKFLAG
        {
            // Static mask
            ESIO_SMASK_PIN_FULL = 0x0001,
            ESIO_SMASK_CONFIGURABLE = 0x0002,
            // Dynamic mask
            ESIO_DMASK_DIRECTION = 0x0020,
        }

        //===============================================================
        // Multi IIC       
        //
        private int iMultiIICWriteNum;
        enum ESII_MASKFLAG
        {
            ESII_TYPE_PRIMARY = 1,
            ESII_TYPE_SMBUS = 2
        }

        //===============================================================
        // Hardware Monitor (HWM)       
        //
        private System.Windows.Forms.Timer timerHWM = new System.Windows.Forms.Timer();
        private const int timerIntervalHWM = 500;
        private UInt32 u32VoltSupport;
        private UInt16 u16TempSupport, u16FanSupport;
        private bool isHWMStart = false;
        // Voltage flag
        private const int VCORE = 1 << 0; // Vcore
        private const int V25   = 1 << 1;   // 2.5V
        private const int V33   = 1 << 2;   // 3.3V
        private const int V50   = 1 << 3;   // 5V
        private const int V120  = 1 << 4;  // 12V
        private const int VSB   = 1 << 5;   // Voltage of standby
        private const int VBAT  = 1 << 6;  // Voltage of battery
        private const int VN50  = 1 << 7;  // -5V
        private const int VN120 = 1 << 8; // -12V
        private const int VTT   = 1 << 9;   // VTT
        // Temperature flag
        private const int TCPU  = 1 << 0; // CPU temperature
        private const int TSYS  = 1 << 1; // System temperature
        // Fan speed flag
        private const int FCPU  = 1 << 0; // CPU fan speed
        private const int FSYS  = 1 << 1; // System fan speed
        private const int F2ND  = 1 << 2; // Other fan speed




       
        public Form1()
        {
            int ret;



            if (Environment.OSVersion.Platform == PlatformID.WinCE)
                gisWinCE = true;

            InitializeComponent();

            if (!SusiDllInit())
            {
                MessageBox.Show("SusiDllInit failed! " + "ErrorCode = " + SusiDllGetLastError().ToString());
                return;
            }

            // Watchdog (WD)
            ret = SusiWDAvailable();
            if (ret < 0)
                MessageBox.Show("SusiWDAvailable failed! " + "ErrorCode = " + SusiDllGetLastError().ToString());
            else if (ret == 1)
                WDTInitialize();
            else
                tabControl1.Controls.Remove(tabPageWDT);

            // GPIO
            ret = SusiIOAvailable();
            if (ret < 0)
                MessageBox.Show("SusiIOAvailable failed! " + "ErrorCode = " + SusiDllGetLastError().ToString());
            else if (ret == 1)
            {
                ret = IOInitialize();
                if (ret == 0)
                    tabControl1.Controls.Remove(tabPageGPIO);

                IOEXInitialize();
            }
            else
            {
                tabControl1.Controls.Remove(tabPageGPIO);
                tabControl1.Controls.Remove(tabPageGPIOEx);
            }

            // SMBus
            ret = SusiSMBusAvailable();
            if (ret < 0)
                MessageBox.Show("SusiSMBusAvailable failed! " + "ErrorCode = " + SusiDllGetLastError().ToString());
            else if (ret == 1)
                SMInitialize();
            else
                tabControl1.Controls.Remove(tabPageSMBus);

            // IIC
            ret = SusiIICAvailable();
            if (ret < 0)
                MessageBox.Show("SusiIICAvailable failed! " + "ErrorCode = " + SusiDllGetLastError().ToString());
             else if (ret == 0)
             {
                 tabControl1.Controls.Remove(tabPageMultiIIC);
             }
             else
             {   
                 if ((ret & (int)ESII_MASKFLAG.ESII_TYPE_PRIMARY) > 0)
                 {
                     radioButtonMultiIICPrimary.Enabled = true;
                 }

                 if ((ret & (int)ESII_MASKFLAG.ESII_TYPE_SMBUS) > 0)
                 {
                     radioButtonMultiIICSMBus.Enabled = true;
                 }
             }


            // VGA Control (VC)
            
            ret = SusiVCAvailable();
            if (ret < 0)
                MessageBox.Show("SusiVCAvailable failed! " + "ErrorCode = " + SusiDllGetLastError().ToString());
            else if (ret == 0)
                tabControl1.Controls.Remove(tabPageVC);
            else if (ret == 1 || ret == 3)               
                VCInitialize();

            // Hardware Monitor (HWM)
            ret = SusiHWMAvailable();
            if (ret < 0)
                MessageBox.Show("SusiHWMAvailable failed! " + "ErrorCode = " + SusiDllGetLastError().ToString());
            else if (ret == 1)
                HWMInitialize();
            else
                tabControl1.Controls.Remove(tabPageHWM);

            // About
            AboutInitialize();
        }

        private void Form1_Closed(object sender, EventArgs e)
        {
            SusiDllUnInit();
        }

        //===============================================================
        // About       
        //
        private unsafe void AboutInitialize()
        {
            string PlatformName = "", BIOSVersion = "", SUSIVersion = "";
            UInt32 susiMajor, susiMinor;

            //
            // Get platform name
            //
            int size = SusiGetPlatformName(null,0);            
            if (size > 0)
            {
                ASCIIEncoding encodeA = new ASCIIEncoding();
                UnicodeEncoding encodeW = new UnicodeEncoding();
     
                if (gisWinCE)
                    size = size * 2;

                byte[] name = new byte[size];
                fixed (byte* p = name)
                if (SusiGetPlatformName((char*)p, (byte)size) == 0)
                {
                    if (gisWinCE)
                        PlatformName = encodeW.GetString(name, 0, size);
                    else
                        PlatformName = encodeA.GetString(name, 0, size);           
                }
                else
                {
                    PlatformName = "UnKnown ";  // add one ' ' as dumby char
                }
            }
            else if (size <= 0)
            {
                PlatformName = "UnKnown ";
            }
            //
            // Get BIOS version
            //
            size = SusiGetBIOSVersion(null,0);            
            if (size > 0)
            {
                ASCIIEncoding encodeA = new ASCIIEncoding();
                UnicodeEncoding encodeW = new UnicodeEncoding();

                if (gisWinCE)
                    size = size*2;
               
                byte[] version = new byte[size];
                fixed (byte* p = version)
                if (SusiGetBIOSVersion((char*)p, (byte)size) == 0)
                {
                    if (gisWinCE)
                        BIOSVersion = encodeW.GetString(version, 0, size);
                    else
                        BIOSVersion = encodeA.GetString(version, 0, size);   
                }
                else
                {
                    BIOSVersion = "UnKnown ";
                }
            }
            else if (size <= 0)
            {
                BIOSVersion = "UnKnown ";
            }
            //
            // Get SUSI version
            //
            SusiDllGetVersion(&susiMajor, &susiMinor);
            SUSIVersion = susiMajor.ToString() + '.' + susiMinor.ToString();

            PlatformName = PlatformName.Substring(0, PlatformName.Length - 1);  // trim the last wierd char
            BIOSVersion = BIOSVersion.Substring(0, BIOSVersion.Length - 1);
            Text = "SUSIDemo : " + PlatformName + " " + BIOSVersion;
            
            labelAboutPlatformName.Text = "Platform Name : " + PlatformName;
            labelAboutBIOSVer.Text = "BIOS Version : " + BIOSVersion;
            labelAboutSusiDemoVer.Text = "SusiDemo Version : " + SUSIVersion;   // mod
        }


        //===============================================================
        // CORE (Boot Logger)  
        //
        private unsafe void buttonCoreBootCounterGet_Click(object sender, EventArgs e)
        {
            uint opeartionflag = 0;
            bool enable;
            uint bootTimes;

            if (checkBoxCoreEnable.Checked)
            {
                opeartionflag |= (uint)ESCORE_BOOTCOUNTER.ESCORE_BOOTCOUNTER_STATUS;
            }
            if (checkBoxCoreBootTimes.Checked)
            {
                opeartionflag |= (uint)ESCORE_BOOTCOUNTER.ESCORE_BOOTCOUNTER_VALUE;
            }


            bool ret = SusiCoreAccessBootCounter((uint)ESCORE_BOOTCOUNTER_MODE.ESCORE_BOOTCOUNTER_MODE_GET, opeartionflag, &enable, &bootTimes);
            if (!ret)
            {
                MessageBox.Show("SusiCoreAccessBootCounter(Get) failed! " + "ErrorCode = " + SusiDllGetLastError().ToString());
                return;
            }

            if (checkBoxCoreEnable.Checked)
            {
                
                textBoxCoreEnable.Text = enable.ToString();
            }
            else
            {
                textBoxCoreEnable.Text = "";
            }

            if (checkBoxCoreBootTimes.Checked)
            {
                textBoxCoreBootTimes.Text = bootTimes.ToString();
            }
            else
            {
                textBoxCoreBootTimes.Text = "";
            }
        }

        private unsafe void buttonCoreBootCounterSet_Click(object sender, EventArgs e)
        {
            uint opeartionflag = 0;
            bool enable;
            uint bootTimes;

            if (checkBoxCoreEnable.Checked)
            {
                opeartionflag |= (uint)ESCORE_BOOTCOUNTER.ESCORE_BOOTCOUNTER_STATUS;

                enable = Convert.ToBoolean(textBoxCoreEnable.Text);
            }
            if (checkBoxCoreBootTimes.Checked)
            {
                opeartionflag |= (uint)ESCORE_BOOTCOUNTER.ESCORE_BOOTCOUNTER_VALUE;

                bootTimes = Convert.ToUInt32(textBoxCoreBootTimes.Text);
            }

            bool ret = SusiCoreAccessBootCounter((uint)ESCORE_BOOTCOUNTER_MODE.ESCORE_BOOTCOUNTER_MODE_SET, opeartionflag, &enable, &bootTimes);
            if (!ret)
            {
                MessageBox.Show("SusiCoreAccessBootCounter(Set) failed! " + "ErrorCode = " + SusiDllGetLastError().ToString());
            }
        }

        private void buttonCoreRunTimerGet_Click(object sender, EventArgs e)
        {
            SSCORE_RUNTIMER RunTimer = new SSCORE_RUNTIMER();

            RunTimer.dwOPFlag = 0;

            if (checkBoxCoreRunning.Checked)
            {
                RunTimer.dwOPFlag |= (uint)ESCORE_RUNTIMER.ESCORE_RUNTIMER_STATUS_RUNNING;
            }

            if (checkBoxCoreAutorun.Checked)
            {
                RunTimer.dwOPFlag |= (uint)ESCORE_RUNTIMER.ESCORE_RUNTIMER_STATUS_AUTORUN;
            }

            if (checkBoxCoreContinualOn.Checked)
            {
                RunTimer.dwOPFlag |= (uint)ESCORE_RUNTIMER.ESCORE_RUNTIMER_VALUE_CONTINUALON;
            }

            if (checkBoxCoreTotalOn.Checked)
            {
                RunTimer.dwOPFlag |= (uint)ESCORE_RUNTIMER.ESCORE_RUNTIMER_VALUE_TOTALON;
            }

            bool ret = SusiCoreAccessRunTimer((uint)ESCORE_RUNTIMER_MODE.ESCORE_RUNTIMER_MODE_GET, ref RunTimer);
            if (!ret)
            {
                MessageBox.Show("SusiCoreAccessRunTimer(Get) failed! " + "ErrorCode = " + SusiDllGetLastError().ToString());
                return;
            }

            if (checkBoxCoreRunning.Checked)
            {
                textBoxCoreRunning.Text = RunTimer.isRunning.ToString();
            }
            else
            {
                textBoxCoreRunning.Text = "";
            }

            if (checkBoxCoreAutorun.Checked)
            {
                textBoxCoreAutorun.Text = RunTimer.isAutorun.ToString();
            }
            else
            {
                textBoxCoreAutorun.Text = "";
            }

            if (checkBoxCoreContinualOn.Checked)
            {
                textBoxCoreContinualOn.Text = RunTimer.dwTimeContinual.ToString();
            }
            else
            {
                textBoxCoreContinualOn.Text = "";
            }

            if (checkBoxCoreTotalOn.Checked)
            {
                textBoxCoreTotalOn.Text = RunTimer.dwTimeTotal.ToString();
            }
            else
            {
                textBoxCoreTotalOn.Text = "";
            }
        }

        private void buttonCoreRunTimerSet_Click(object sender, EventArgs e)
        {
            SSCORE_RUNTIMER RunTimer = new SSCORE_RUNTIMER();

            RunTimer.dwOPFlag = 0;

            if (checkBoxCoreRunning.Checked)
            {
                RunTimer.dwOPFlag |= (uint)ESCORE_RUNTIMER.ESCORE_RUNTIMER_STATUS_RUNNING;

                RunTimer.isRunning = Convert.ToInt32(textBoxCoreRunning.Text);
            }

            if (checkBoxCoreAutorun.Checked)
            {
                RunTimer.dwOPFlag |= (uint)ESCORE_RUNTIMER.ESCORE_RUNTIMER_STATUS_AUTORUN;

                RunTimer.isAutorun = Convert.ToInt32(textBoxCoreAutorun.Text);
            }

            if (checkBoxCoreContinualOn.Checked)
            {
                RunTimer.dwOPFlag |= (uint)ESCORE_RUNTIMER.ESCORE_RUNTIMER_VALUE_CONTINUALON;

                RunTimer.dwTimeContinual = Convert.ToUInt32(textBoxCoreContinualOn.Text);
            }

            if (checkBoxCoreTotalOn.Checked)
            {
                RunTimer.dwOPFlag |= (uint)ESCORE_RUNTIMER.ESCORE_RUNTIMER_VALUE_TOTALON;

                RunTimer.dwTimeTotal = Convert.ToUInt32(textBoxCoreTotalOn.Text);
            }

            bool ret = SusiCoreAccessRunTimer((uint)ESCORE_RUNTIMER_MODE.ESCORE_RUNTIMER_MODE_SET, ref RunTimer);
            if (!ret)
            {
                MessageBox.Show("SusiCoreAccessRunTimer(Set) failed! " + "ErrorCode = " + SusiDllGetLastError().ToString());
            }
        }

        //===============================================================
        // Watchdog       
        //
        private void WDTInitializeButtons(string occasion)
        {
            switch(occasion)
            {
                case "Init":
                    buttonWDTStart.Enabled = true;
                    buttonWDTRefresh.Enabled = false;
                    buttonWDTStop.Enabled = false;
                    break;
                case "Start":
                    buttonWDTStart.Enabled = false;
                    buttonWDTRefresh.Enabled = true;
                    buttonWDTStop.Enabled = true;
                    break;
                case "Stop":
                    buttonWDTStart.Enabled = true;
                    buttonWDTRefresh.Enabled = false;
                    buttonWDTStop.Enabled = false;
                    break;
                default:
                    MessageBox.Show("Invalid parameter");
                    return;
            }
        }
        
        private unsafe void WDTInitialize()
        {            
            UInt32 min, max, step;             
            
            if (!SusiWDGetRange(&min, &max, &step))
            {
                MessageBox.Show("SusiWDGetRange failed! " + "ErrorCode = " + SusiDllGetLastError().ToString());
                return;
            }

            textBoxWDTMin.Text = min.ToString();
            textBoxWDTMax.Text = max.ToString();
            textBoxWDTStep.Text = step.ToString();

            WDTInitializeButtons("Init");
        }

        public void WDTInitializeTimer()
        {
            timerWDT.Tick += new EventHandler(WDTOnTick);
            timerWDT.Interval = timerIntervalWDT;
            timerWDT.Enabled = true;
            textBoxWDTLeft.Text = iTimerCountDownWDT.ToString();
        }

        public void WDTDeInitializeTimer()
        {
            timerWDT.Enabled = false;
        }

        private void WDTOnTick(object s, EventArgs ea)
        {			/*
            if (iTimerCountDownWDT >= timerIntervalWDT)
                iTimerCountDownWDT -= timerIntervalWDT;
            textBoxWDTLeft.Text = iTimerCountDownWDT.ToString();
			*/
			if ((WDTTimeStamp-DateTime.Now ) > (DateTime.Now - DateTime.Now))
				textBoxWDTLeft.Text = Convert.ToString(WDTTimeStamp - DateTime.Now);
        }

        private void buttonWDTStart_Click(object sender, EventArgs e)
        {
            int delay = Convert.ToInt32(textBoxWDTDelay.Text);  // Josh : exception handling
            iTimeOutWDT = Convert.ToInt32(textBoxWDTTimeOut.Text);
            iTimerCountDownWDT = iTimeOutWDT + delay;

			//Get system current time.
			WDTTimeStamp = DateTime.Now.AddMilliseconds(iTimerCountDownWDT);
			//MessageBox.Show(WDTTimeStamp.ToShortTimeString());

            if (!SusiWDSetConfig((uint)delay, (uint)iTimeOutWDT))
            {
                MessageBox.Show("SusiWDSetConfig failed! " + "ErrorCode = " + SusiDllGetLastError().ToString());
                return;
            }

            WDTInitializeTimer();
            WDTInitializeButtons("Start");
        }

        private void buttonWDTRefresh_Click(object sender, EventArgs e)
        {
            iTimerCountDownWDT = Convert.ToInt32(textBoxWDTTimeOut.Text);

            //Get system current time.
            WDTTimeStamp = DateTime.Now.AddMilliseconds(iTimerCountDownWDT);

            if (!SusiWDTrigger())
            {
                MessageBox.Show("SusiWDTrigger failed! " + "ErrorCode = " + SusiDllGetLastError().ToString());
                return;
            }

            WDTInitializeTimer();           
            
            /*
            if (!SusiWDTrigger())
            {
                MessageBox.Show("SusiWDTrigger failed! " + "ErrorCode = " + SusiDllGetLastError().ToString());
                return;
            }

            iTimerCountDownWDT = iTimeOutWDT; // reset countdown value
            textBoxWDTLeft.Text = iTimerCountDownWDT.ToString();
          */ 
        }

        private void buttonWDTStop_Click(object sender, EventArgs e)
        {
            if (!SusiWDDisable())
            {
                MessageBox.Show("SusiWDDisable failed! " + "ErrorCode = " + SusiDllGetLastError().ToString());
                return;
            }

            WDTDeInitializeTimer();
            WDTInitializeButtons("Stop");
        }

        //===============================================================
        // Programmable GPIO 
        //
        private void IOEXInitialize()
        {
            checkBoxIOEXMultiPin.Checked = true;
        }

        private unsafe void buttonIOEXGetPinCount_Click(object sender, EventArgs e)
        {
            UInt32 inCount, outCount;

            if (!SusiIOCountEx(&inCount, &outCount))
            {
                MessageBox.Show("SusiIOCountEx failed! " + "ErrorCode = " + SusiDllGetLastError().ToString());
                return;
            }

            textBoxIOEXNumIn.Text = inCount.ToString();
            textBoxIOEXNumOut.Text = outCount.ToString();
        }


        private unsafe void buttonIOEXSetDirection_Click_1(object sender, EventArgs e)
        {
			//If select single pin.
            if (checkBoxIOEXSinglePin.Checked)
            {
                UInt32 pinDirAfterSet;
                byte pinNum = Convert.ToByte(textBoxIOEXSinglePin.Text);
                byte IO = Convert.ToByte(textBoxIOEXPinValue.Text, 2);

                if (!SusiIOSetDirection(pinNum, IO, &pinDirAfterSet))
                {
                    MessageBox.Show("SusiIOSetDirection failed! " + "ErrorCode = " + SusiDllGetLastError().ToString());
                    return;
                }

                textBoxIOEXPinValue.Text = Convert.ToString(pinDirAfterSet, 2);
            }

			//If select multi pin.
            if (checkBoxIOEXMultiPin.Checked)
            {
                UInt32 targetPinMask = Convert.ToUInt32(textBoxIOEXMultiPin.Text, 2);
                UInt32 pinDirMask = Convert.ToUInt32(textBoxIOEXPinValue.Text, 2);
                UInt32 pinDirAfterSet = pinDirMask;

                if (!SusiIOSetDirectionMulti(targetPinMask, &pinDirAfterSet))
                {
                    MessageBox.Show("SusiIOSetDirectionMulti failed! " + "ErrorCode = " + SusiDllGetLastError().ToString());
                    return;
                }

                textBoxIOEXPinValue.Text = Convert.ToString(pinDirAfterSet, 2);
            }
        }

        private unsafe void buttonIOEXRead_Click_1(object sender, EventArgs e)
        {
            if (checkBoxIOEXSinglePin.Checked)
            {
                Int32 status;
                byte pinNum = Convert.ToByte(textBoxIOEXSinglePin.Text);

                if (!SusiIOReadEx(pinNum, &status))
                {
                    MessageBox.Show("SusiIOReadEx failed! " + "ErrorCode = " + SusiDllGetLastError().ToString());
                    return;
                }

                textBoxIOEXPinValue.Text = Convert.ToString(status, 2);
            }
            else if (checkBoxIOEXMultiPin.Checked)
            {
                UInt32 targetPinMask = Convert.ToUInt32(textBoxIOEXMultiPin.Text, 2);
                UInt32 statusMask;

                if (!SusiIOReadMultiEx(targetPinMask, &statusMask))
                {
                    MessageBox.Show("SusiIOReadMultiEx failed! " + "ErrorCode = " + SusiDllGetLastError().ToString());
                    return;
                }

                textBoxIOEXPinValue.Text = Convert.ToString(statusMask, 2);
            }
        }

        private unsafe void buttonIOEXWrite_Click_1(object sender, EventArgs e)
        {
            if (checkBoxIOEXSinglePin.Checked)
            {
                Int32 status = Convert.ToInt32(textBoxIOEXPinValue.Text, 2);
                byte pinNum = Convert.ToByte(textBoxIOEXSinglePin.Text);

                if (!SusiIOWriteEx(pinNum, status))
                {
                    MessageBox.Show("SusiIOWriteEx failed! " + "ErrorCode = " + SusiDllGetLastError().ToString());
                    return;
                }
            }
            else if (checkBoxIOEXMultiPin.Checked)
            {
                UInt32 targetPinMask = Convert.ToUInt32(textBoxIOEXMultiPin.Text, 2);
                UInt32 statusMask = Convert.ToUInt32(textBoxIOEXPinValue.Text, 2);

                if (!SusiIOWriteMultiEx(targetPinMask, statusMask))
                {
                    MessageBox.Show("SusiIOWriteMultiEx failed! " + "ErrorCode = " + SusiDllGetLastError().ToString());
                    return;
                }
            }
        }
   
        private unsafe void buttonIOEXGetMask_Click(object sender, EventArgs e)
        {
            UInt32 mask;

            if (checkBoxIOEXFullPin.Checked)
            {
                if (!SusiIOQueryMask((uint)ESIO_MASKFLAG.ESIO_SMASK_PIN_FULL, &mask))
                {
                    MessageBox.Show("SusiIOQueryMask failed! " + "ErrorCode = " + SusiDllGetLastError().ToString());
                    return;
                }

                textBoxIOEXAllPin.Text = Convert.ToString(mask, 2);
            }
            else
            {
                textBoxIOEXAllPin.Text = "";
            }

            if (checkBoxIOEXIOConfigurable.Checked)
            {
                if (!SusiIOQueryMask((uint)ESIO_MASKFLAG.ESIO_SMASK_CONFIGURABLE, &mask))
                {
                    MessageBox.Show("SusiIOQueryMask failed! " + "ErrorCode = " + SusiDllGetLastError().ToString());
                    return;
                }

                textBoxIOEXIOConfigurable.Text = Convert.ToString(mask, 2);
            }
            else
            {
                textBoxIOEXIOConfigurable.Text = "";
            }


            if (checkBoxIOEXIODirection.Checked)
            {
                if (!SusiIOQueryMask((uint)ESIO_MASKFLAG.ESIO_DMASK_DIRECTION, &mask))
                {
                    MessageBox.Show("SusiIOQueryMask failed! " + "ErrorCode = " + SusiDllGetLastError().ToString());
                    return;
                }

                textBoxIOEXIODirection.Text = Convert.ToString(mask, 2);
            }
            else
            {
                textBoxIOEXIODirection.Text = "";
            }
        }


        private void checkBoxIOEXSinglePin_CheckStateChanged_1(object sender, EventArgs e)
        {
            if (checkBoxIOEXSinglePin.Checked)
            {
                checkBoxIOEXMultiPin.Checked = false;
                textBoxIOEXMultiPin.Text = "";
                textBoxIOEXMultiPin.Enabled = false;
                textBoxIOEXSinglePin.Enabled = true;
            }
        }

        private void checkBoxIOEXMultiPin_CheckStateChanged_1(object sender, EventArgs e)
        {
            if (checkBoxIOEXMultiPin.Checked)
            {
                checkBoxIOEXSinglePin.Checked = false;
                textBoxIOEXSinglePin.Text = "";
                textBoxIOEXSinglePin.Enabled = false;
                textBoxIOEXMultiPin.Enabled = true;
            }
        }

        //===============================================================
        // GPIO (backward-compatible)    
        // 
        private unsafe int IOInitialize()
        {
            UInt16 inCount, outCount;

            if (!SusiIOInitial(0))
            {
                // Check if it's old API unsupport error
                if (SusiDllGetLastError() == (30400000 + 7))
                {
                    return 0; // Old API unsupport
                }
                else
                {
                    MessageBox.Show("SusiIOInitial failed! " + "ErrorCode = " + SusiDllGetLastError().ToString());
                    return -1;
                }
            }

            if (!SusiIOCount(&inCount, &outCount))
            {
                MessageBox.Show("SusiIOCount failed! " + "ErrorCode = " + SusiDllGetLastError().ToString());
                return -1;
            }

            textBoxIOInNum.Text = inCount.ToString();
            textBoxIOOutNum.Text = outCount.ToString();

            radioButtonIOOnePin.Checked = true;  // will invoke CheckedChanged event
            radioButtonIOMultiPin.Checked = false;

            return 1;
        }

        private void radioButtonIOOnePin_CheckedChanged(object sender, EventArgs e)
        {
            if (radioButtonIOOnePin.Checked)
            {
                textBoxIOOnePin.Enabled = true;
                textBoxIOMultiPin.Enabled = false;
            }
            else
            {
                textBoxIOOnePin.Enabled = false;
                textBoxIOMultiPin.Enabled = true;                
            }
          
        }       

        private unsafe void buttonIORead_Click(object sender, EventArgs e)
        {         
            if (radioButtonIOOnePin.Checked)
            {
                byte TargetPin;
                bool status;

                TargetPin = Convert.ToByte(textBoxIOOnePin.Text);

                if (!SusiIORead(TargetPin, &status))
                {
                    MessageBox.Show("SusiIORead failed! " + "ErrorCode = " + SusiDllGetLastError().ToString());
                    return;
                }

                if (status)
                    textBoxIOResult.Text = "0x1";
                else
                    textBoxIOResult.Text = "0x0";
            }
            else
            {
                UInt32 TargetPinMask, StatusMask; 

                TargetPinMask = Convert.ToUInt32(textBoxIOMultiPin.Text, 16);

                if (!SusiIOReadMulti(TargetPinMask, &StatusMask))
                {
                    MessageBox.Show("SusiIOReadMulti failed! " + "ErrorCode = " + SusiDllGetLastError().ToString());
                    return;
                }

                textBoxIOResult.Text = "0x" + Convert.ToString(StatusMask, 16);
            }
        }

        private void buttonIOWrite_Click(object sender, EventArgs e)
        {
            
            UInt32 StatusMask = Convert.ToUInt32(textBoxIOResult.Text, 16);

            if (radioButtonIOOnePin.Checked)
            {
                byte TargetPin;
                bool status;

                TargetPin = Convert.ToByte(textBoxIOOnePin.Text);
                if (StatusMask < 0x2)
                {
                    if (0x1 == StatusMask)
                        status = true;
                    else 
                        status = false;

                    if (!SusiIOWrite(TargetPin, status))
                    {
                        MessageBox.Show("SusiIOWrite failed! " + "ErrorCode = " + SusiDllGetLastError().ToString());
                        return;
                    }

                    MessageBox.Show("Write single GPIO pin successfully");
                }
                else
                {                    
                    MessageBox.Show("Please assign 1 or 0");
                    return;
                }
            }
            else
            {
                UInt32 TargetPinMask;

                TargetPinMask = Convert.ToUInt32(textBoxIOMultiPin.Text, 16);

                if (!SusiIOWriteMulti(TargetPinMask, StatusMask))
                {
                    MessageBox.Show("SusiIOWriteMulti failed! " + "ErrorCode = " + SusiDllGetLastError().ToString());
                    return;
                }

                MessageBox.Show("Write multiple GPIO pins successfully");
            }            
        }

        //===============================================================
        // SMBus      
        //

        private void SMInitialize()
        {
            radioButtonSMByteData.Checked = true;  // Default Byte Data checked

            radioButtonSMBlockData.Checked = false;
            radioButtonSMByte.Checked = false;
            radioButtonSMQuick.Checked = false;
            radioButtonSMWordData.Checked = false;
            textBoxSMBlockData.Enabled = false;
        }

        private void radioButtonSMQuick_CheckedChanged(object sender, EventArgs e)
        {
            if (radioButtonSMQuick.Checked)
            {
                radioButtonSMByteData.Checked = false;
                radioButtonSMBlockData.Checked = false;
                radioButtonSMByte.Checked = false;
                radioButtonSMQuick.Checked = true;
                radioButtonSMWordData.Checked = false;
                textBoxSMBlockData.Enabled = false;
                textBoxSMRegOffset.Enabled = false;
                textBoxSMResult.Enabled = false;
            }
        }

        private void radioButtonSMByte_CheckedChanged(object sender, EventArgs e)
        {
            if (radioButtonSMByte.Checked)
            {
                radioButtonSMByteData.Checked = false;
                radioButtonSMBlockData.Checked = false;
                radioButtonSMByte.Checked = true;
                radioButtonSMQuick.Checked = false;
                radioButtonSMWordData.Checked = false;
                textBoxSMBlockData.Enabled = false;
                textBoxSMRegOffset.Enabled = false;
                textBoxSMResult.Enabled = true;
            }
        }

        private void radioButtonSMByteData_CheckedChanged(object sender, EventArgs e)
        {
            if (radioButtonSMByteData.Checked)
            {
                radioButtonSMByteData.Checked = true;
                radioButtonSMBlockData.Checked = false;
                radioButtonSMByte.Checked = false;
                radioButtonSMQuick.Checked = false;
                radioButtonSMWordData.Checked = false;
                textBoxSMBlockData.Enabled = false;
                textBoxSMRegOffset.Enabled = true;
                textBoxSMResult.Enabled = true;
            }
        }

        private void radioButtonSMWordData_CheckedChanged(object sender, EventArgs e)
        {
            if (radioButtonSMWordData.Checked)
            {
                radioButtonSMByteData.Checked = false;
                radioButtonSMBlockData.Checked = false;
                radioButtonSMByte.Checked = false;
                radioButtonSMQuick.Checked = false;
                radioButtonSMWordData.Checked = true;
                textBoxSMBlockData.Enabled = false;
                textBoxSMRegOffset.Enabled = true;
                textBoxSMResult.Enabled = true;
            }
        }

        private void radioButtonSMBlockData_CheckedChanged(object sender, EventArgs e)
        {
            if (radioButtonSMBlockData.Checked)
            {
                radioButtonSMByteData.Checked = false;
                radioButtonSMBlockData.Checked = true;
                radioButtonSMByte.Checked = false;
                radioButtonSMQuick.Checked = false;
                radioButtonSMWordData.Checked = false;
                textBoxSMBlockData.Enabled = true;
                textBoxSMRegOffset.Enabled = true;
                textBoxSMResult.Enabled = true;
            }
        }

        private unsafe void buttonSMRead_Click(object sender, EventArgs e)
        {           
            byte SlaveAddr = Convert.ToByte(textBoxSMSlaveAddr.Text, 16);
            byte RegOffset = Convert.ToByte(textBoxSMRegOffset.Text, 16);

            if (radioButtonSMBlockData.Checked)
            {
                byte count = Convert.ToByte(textBoxSMBlockData.Text);
                byte[] Result = new byte[count];
                string output = "";

                fixed (byte* p = Result)
                if (!SusiSMBusReadBlock(SlaveAddr, RegOffset, p, &count))
                {
                    MessageBox.Show("SusiSMBusReadBlock failed! " + "ErrorCode = " + SusiDllGetLastError().ToString());
                    return;
                }     

                for (int i = 0; i < count; i++)
                {
                    output += "0x" + Convert.ToString(Result[i], 16);
                    if (i != count - 1)
                        output += ",";
                }

                textBoxSMResult.Text = output;
            }
            else if (radioButtonSMByte.Checked)
            {
                byte Result;

                if (!SusiSMBusReceiveByte(SlaveAddr, &Result))
                {
                    MessageBox.Show("SusiSMBusReceiveByte failed! " + "ErrorCode = " + SusiDllGetLastError().ToString());
                    return;
                }

                textBoxSMResult.Text = "0x" + Convert.ToString(Result, 16);
            }
            else if (radioButtonSMByteData.Checked)
            {
                byte Result;

                if (!SusiSMBusReadByte(SlaveAddr, RegOffset, &Result))
                {
                    MessageBox.Show("SusiSMBusReadByte failed! " + "ErrorCode = " + SusiDllGetLastError().ToString());
                    return;
                }

                textBoxSMResult.Text = "0x" + Convert.ToString(Result, 16);
            }
            else if (radioButtonSMQuick.Checked)
            {
                if (!SusiSMBusReadQuick(SlaveAddr))
                {
                    MessageBox.Show("SusiSMBusReadQuick failed! " + "ErrorCode = " + SusiDllGetLastError().ToString());
                    return;
                }
            }
            else if (radioButtonSMWordData.Checked)
            {
                UInt16 Result;

                if (!SusiSMBusReadWord(SlaveAddr, RegOffset, &Result))
                {
                    MessageBox.Show("SusiSMBusReadWord failed! " + "ErrorCode = " + SusiDllGetLastError().ToString());
                    return;
                }

                textBoxSMResult.Text = "0x" + Convert.ToString(Result, 16);
            }
        }

        private unsafe void buttonSMWrite_Click(object sender, EventArgs e)
        {
            byte SlaveAddr = Convert.ToByte(textBoxSMSlaveAddr.Text, 16);
            byte RegOffset = Convert.ToByte(textBoxSMRegOffset.Text, 16);

            if (radioButtonSMBlockData.Checked)
            {
                int pos1 = 0, pos2 = 0;
                byte count = Convert.ToByte(textBoxSMBlockData.Text);
                byte[] Result = new byte[count];
                string input = "";

                // Look for all data demanded to write via SMBus
                for (int i = 0; i < count; i++)
                {
                    pos2 = textBoxSMResult.Text.IndexOf(',', pos1);

                    if ((pos1 != pos2 + 1) && (pos2 != -1))
                    {
                        input = textBoxSMResult.Text.Substring(pos1, pos2 - pos1);
                        Result[i] = Convert.ToByte(input, 16);
                        pos1 = pos2 + 1;
                    }
                    else if (pos2 == -1)
                    {
                        pos2 = textBoxSMResult.Text.Length;
                        input = textBoxSMResult.Text.Substring(pos1, pos2 - pos1); // Get the data
                        Result[i] = Convert.ToByte(input, 16);
                    }
                }

                fixed (byte* p = Result)
                if (!SusiSMBusWriteBlock(SlaveAddr, RegOffset, p, count))
                {
                    MessageBox.Show("SusiSMBusWriteBlock failed! " + "ErrorCode = " + SusiDllGetLastError().ToString());
                    return;
                }               
            }
            else if (radioButtonSMByte.Checked)
            {
                byte Result = Convert.ToByte(textBoxSMResult.Text, 16);

                if (!SusiSMBusSendByte(SlaveAddr, Result))
                {
                    MessageBox.Show("SusiSMBusSendByte failed! " + "ErrorCode = " + SusiDllGetLastError().ToString());
                    return;
                }
            }
            else if (radioButtonSMByteData.Checked)
            {
                byte Result = Convert.ToByte(textBoxSMResult.Text, 16);

                if (!SusiSMBusWriteByte(SlaveAddr, RegOffset, Result))
                {
                    MessageBox.Show("SusiSMBusWriteByte failed! " + "ErrorCode = " + SusiDllGetLastError().ToString());
                    return;
                }
            }
            else if (radioButtonSMQuick.Checked)
            {
                if (!SusiSMBusWriteQuick(SlaveAddr))
                {
                    MessageBox.Show("SusiSMBusWriteQuick failed! " + "ErrorCode = " + SusiDllGetLastError().ToString());
                    return;
                }
            }
            else if (radioButtonSMWordData.Checked)
            {
                UInt16 Result = Convert.ToUInt16(textBoxSMResult.Text, 16);

                if (!SusiSMBusWriteWord(SlaveAddr, RegOffset, Result))
                {
                    MessageBox.Show("SusiSMBusWriteWord failed! " + "ErrorCode = " + SusiDllGetLastError().ToString());
                    return;
                }
            }
        }

        private void buttonSMScan_Click(object sender, EventArgs e)
        {
            int[] Result = new int[128];
            string output = "";

            for (byte i = 0; i <= 0x7F; i++)
            {
                int ret = SusiSMBusScanDevice(i);
                if (ret < 0)
                {
                    MessageBox.Show("SusiSMBusScanDevice failed! " + "ErrorCode = " + SusiDllGetLastError().ToString());
                    return;
                }

                Result[i] = ret;
            }

            for (byte i = 0; i <= 0x7F; i++)
            {
                if (Result[i] == 1)
                {
                    int temp = i<<1;
                    output += "0x" + Convert.ToString(temp, 16);
                    if (i != 0x7F)
                        output += ",";
                }
            }

            textBoxSMResult.Text = output;
        }

        //===============================================================
        // MultiByte IIC      
        //
        private void radioButtonMultiIICPrimary_CheckedChanged(object sender, EventArgs e)
        {
            if (radioButtonMultiIICPrimary.Checked)
                radioButtonMultiIICSMBus.Checked = false;
        }

        private void radioButtonMultiIICSMBus_CheckedChanged(object sender, EventArgs e)
        {
            if (radioButtonMultiIICSMBus.Checked)
                radioButtonMultiIICPrimary.Checked = false;
        }

        private unsafe void buttonMultiIICRead_Click_1(object sender, EventArgs e)
        {
            byte SlaveAddr = Convert.ToByte(textBoxMultiIICSlaveAddr.Text, 16);
            UInt32 ReadNum = Convert.ToUInt32(textBoxMultiIICReadNum.Text);
            byte[] Result = new byte[ReadNum];
            string output = "";
            UInt32 flag;

            if (radioButtonMultiIICPrimary.Checked)
                flag = (uint)ESII_MASKFLAG.ESII_TYPE_PRIMARY;
            else if (radioButtonMultiIICSMBus.Checked)
                flag = (uint)ESII_MASKFLAG.ESII_TYPE_SMBUS;
            else
            {
                MessageBox.Show("Please choose IIC Type!");
                return;
            }

            fixed (byte* p = Result)
                if (!SusiIICRead(flag, SlaveAddr, p, ReadNum))
                {
                    MessageBox.Show("SusiIICRead failed! " + "ErrorCode = " + SusiDllGetLastError().ToString());
                    return;
                }

            for (int i = 0; i < ReadNum; i++)
            {
                output += Convert.ToString(Result[i], 16);
                output += " ";
            }

            textBoxMultiIICResult.Text = output;
        }

        private unsafe void buttonMultiIICWrite_Click_1(object sender, EventArgs e)
        {
            int pos1 = 0, pos2 = 0;
            byte SlaveAddr = Convert.ToByte(textBoxMultiIICSlaveAddr.Text, 16);
            byte[] Result = new byte[iMultiIICWriteNum];
            string input = "";
            UInt32 flag;

            if (radioButtonMultiIICPrimary.Checked)
                flag = (uint)ESII_MASKFLAG.ESII_TYPE_PRIMARY;
            else if (radioButtonMultiIICSMBus.Checked)
                flag = (uint)ESII_MASKFLAG.ESII_TYPE_SMBUS;
            else
            {
                MessageBox.Show("Please choose IIC Type!");
                return;
            }

            for (int i = 0; i < iMultiIICWriteNum; i++)
            {
                pos2 = textBoxMultiIICInputData.Text.IndexOf(' ', pos1);

                if ((pos1 != pos2 + 1) && (pos2 != -1))
                {
                    input = textBoxMultiIICInputData.Text.Substring(pos1, pos2 - pos1);
                    Result[i] = Convert.ToByte(input, 16);
                    pos1 = pos2 + 1;
                }
                else if (pos2 == -1)
                {
                    pos2 = textBoxMultiIICInputData.Text.Length;
                    input = textBoxMultiIICInputData.Text.Substring(pos1, pos2 - pos1); // Get the data
                    Result[i] = Convert.ToByte(input, 16);
                    break;
                }
            }

            fixed (byte* p = Result)
                if (!SusiIICWrite(flag, SlaveAddr, p, (uint)iMultiIICWriteNum))
                {
                    MessageBox.Show("SusiIICWrite failed! " + "ErrorCode = " + SusiDllGetLastError().ToString());
                    return;
                }
        }

        private unsafe void buttonMultiIICRWCombine_Click_1(object sender, EventArgs e)
        {
            int pos1 = 0, pos2 = 0;
            byte SlaveAddr = Convert.ToByte(textBoxMultiIICSlaveAddr.Text, 16);
            UInt32 ReadNum = Convert.ToUInt32(textBoxMultiIICReadNum.Text);
            byte[] WResult = new byte[iMultiIICWriteNum];
            byte[] RResult = new byte[ReadNum];
            string input = "", output = "";
            UInt32 flag;

            if (radioButtonMultiIICPrimary.Checked)
                flag = (uint)ESII_MASKFLAG.ESII_TYPE_PRIMARY;
            else if (radioButtonMultiIICSMBus.Checked)
                flag = (uint)ESII_MASKFLAG.ESII_TYPE_SMBUS;
            else
            {
                MessageBox.Show("Please choose IIC Type!");
                return;
            }

            //
            // Get data to write
            //
            for (int i = 0; i < iMultiIICWriteNum; i++)
            {
                pos2 = textBoxMultiIICInputData.Text.IndexOf(' ', pos1);

                if ((pos1 != pos2 + 1) && (pos2 != -1))
                {
                    input = textBoxMultiIICInputData.Text.Substring(pos1, pos2 - pos1);
                    WResult[i] = Convert.ToByte(input, 16);
                    pos1 = pos2 + 1;
                }
                else if (pos2 == -1)
                {
                    pos2 = textBoxMultiIICInputData.Text.Length;
                    input = textBoxMultiIICInputData.Text.Substring(pos1, pos2 - pos1); // Get the data
                    WResult[i] = Convert.ToByte(input, 16);
                    break;
                }
            }
            //
            // Read/Write multiple bytes
            //
            fixed (byte* pR = RResult)
            fixed (byte* pW = WResult)
                if (!SusiIICWriteReadCombine(flag, SlaveAddr, pW, (uint)iMultiIICWriteNum, pR, ReadNum))
                {
                    MessageBox.Show("SusiIICWriteReadCombine failed! " + "ErrorCode = " + SusiDllGetLastError().ToString());
                    return;
                }

            for (int i = 0; i < ReadNum; i++)
            {
                output += Convert.ToString(RResult[i], 16);
                output += " ";
            }

            textBoxMultiIICResult.Text = output;
        }

        private void textBoxMultiIICInputData_TextChanged_1(object sender, EventArgs e)
        {
            int pos1 = 0, pos2 = 0;
            int len = textBoxMultiIICInputData.Text.Length;

            iMultiIICWriteNum = 1;

            while (-1 != pos2)
            {
                pos2 = textBoxMultiIICInputData.Text.IndexOf(' ', pos1);
                if (0 == pos2)
                {
                    MessageBox.Show("Frist char cannot be space");
                    return;
                }
                else if ((-1 != pos2) && (pos2 != len - 1))
                {
                    iMultiIICWriteNum++;
                }

                pos1 = pos2 + 1;
            }

            textBoxMultiIICWriteNum.Text = iMultiIICWriteNum.ToString();
        }

        //===============================================================
        // VGA Control (VC)     
        //
        private unsafe void VCInitialize()
        {
            byte min, max, step;
            byte value;

            labelVCBrightNow.Enabled = true;
            trackBarVCBright.Enabled = true;
            buttonVCBrightUp.Enabled = true;
            buttonVCBrightDown.Enabled = true;
            
            //
            // set info about brightness
            //
            if (!SusiVCGetBrightRange(&min, &max, &step))
            {
                MessageBox.Show("SusiVCGetBrightRange failed! " + "ErrorCode = " + SusiDllGetLastError().ToString());
                return;
            }

            labelVCBrightMax.Text = max.ToString();
            labelVCBrightMin.Text = min.ToString();
            trackBarVCBright.Maximum = max;
            trackBarVCBright.Minimum = min;
            trackBarVCBright.SmallChange = step;
            byte ChangeScale = (byte)((max - min) / step);
            trackBarVCBright.LargeChange = step * ChangeScale/2;
            
            // get current brightness value
            if (!SusiVCGetBright(&value))
            {
                MessageBox.Show("SusiVCGetBright failed! " + "ErrorCode = " + SusiDllGetLastError().ToString());
                return;
            }

            trackBarVCBright.Value = value;
            labelVCBrightNow.Text = value.ToString();
        }      

        private void radioButtonVCOff_CheckedChanged_1(object sender, EventArgs e)
        {
            if (radioButtonVCOn.Checked)
            {  
                if (!SusiVCScreenOn())
                {
                    MessageBox.Show("SusiVCScreenOn failed! " + "ErrorCode = " + SusiDllGetLastError().ToString());
                    return;
                }
            }
            else if (radioButtonVCOff.Checked)
            {
                
                if (!SusiVCScreenOff())
                {
                    MessageBox.Show("SusiVCScreenOff failed! " + "ErrorCode = " + SusiDllGetLastError().ToString());
                    return;
                }
                
                radioButtonVCOn.Checked = false;
                radioButtonVCOff.Checked = false;
            }
        }

        private void buttonVCBrightUp_Click(object sender, EventArgs e)
        {
            if (trackBarVCBright.Value == trackBarVCBright.Maximum)
            {
                MessageBox.Show("Reach max value");
                return;
            }
            else if (trackBarVCBright.Value + trackBarVCBright.SmallChange > trackBarVCBright.Maximum)
            {
                trackBarVCBright.Value = trackBarVCBright.Maximum;
            }
            else
            {
                trackBarVCBright.Value += trackBarVCBright.SmallChange;
            }
        }

        private void buttonVCBrightDown_Click(object sender, EventArgs e)
        {
            if (trackBarVCBright.Value == trackBarVCBright.Minimum)
            {
                MessageBox.Show("Reach min value");
                return;
            }
            else if (trackBarVCBright.Value - trackBarVCBright.SmallChange < trackBarVCBright.Minimum)
            {
                trackBarVCBright.Value = trackBarVCBright.Minimum;
            }
            else
            {
                trackBarVCBright.Value -= trackBarVCBright.SmallChange;
            }
        }

        private void trackBarVCBright_ValueChanged(object sender, EventArgs e)
        {
            if (!SusiVCSetBright((byte)trackBarVCBright.Value))
            {
                MessageBox.Show("SusiVCSetBright failed! " + "ErrorCode = " + SusiDllGetLastError().ToString());
                return;
            }

            labelVCBrightNow.Text = trackBarVCBright.Value.ToString();
        }

        //===============================================================
        // Hardware Monitor (HWM)      
        //
        private unsafe void HWMInitialize()
        {
            fixed (UInt32* p = &u32VoltSupport)
                if (!SusiHWMGetVoltage(0, (float*)null, p))
                {
                    MessageBox.Show("SusiHWMGetVoltage failed! " + "ErrorCode = " + SusiDllGetLastError().ToString());
                    return;
                }

            if (0 == (u32VoltSupport & VCORE))
                textBoxHWMVcore.Enabled = false;
            if (0 == (u32VoltSupport & V25))
                textBoxHWMV25.Enabled = false;
            if (0 == (u32VoltSupport & V33))
                textBoxHWMV33.Enabled = false;
            if (0 == (u32VoltSupport & V50))
                textBoxHWMV50.Enabled = false;
            if (0 == (u32VoltSupport & V120))
                textBoxHWMV120.Enabled = false;
            if (0 == (u32VoltSupport & VSB))
                textBoxHWMVsb.Enabled = false;
            if (0 == (u32VoltSupport & VBAT))
                textBoxHWMVbat.Enabled = false;
            if (0 == (u32VoltSupport & VN50))
                textBoxHWMVn50.Enabled = false;
            if (0 == (u32VoltSupport & VN120))
                textBoxHWMVn120.Enabled = false;
            if (0 == (u32VoltSupport & VTT))
                textBoxHWMVtt.Enabled = false;

            fixed (UInt16* q = &u16TempSupport)
            if (!SusiHWMGetTemperature(0, (float *)0, q))
            {
                MessageBox.Show("SusiHWMGetTemperature failed! " + "ErrorCode = " + SusiDllGetLastError().ToString());
                return;
            }

            if (0 == (u16TempSupport & TCPU))
                textBoxHWMTcpu.Enabled = false;
            if (0 == (u16TempSupport & TSYS))
                textBoxHWMTsys.Enabled = false;               

            fixed (UInt16* x = &u16FanSupport)
            if (!SusiHWMGetFanSpeed(0, (ushort*)0, x))
            {
                MessageBox.Show("SusiHWMGetFanSpeed failed! " + "ErrorCode = " + SusiDllGetLastError().ToString());
                return;
            }

            if (0 == (u16FanSupport & FCPU))
                textBoxHWMFcpu.Enabled = false;
            else
                comboBoxHWCFanType.Items.Add("CPU Fan");

            if (0 == (u16FanSupport & FSYS))
                textBoxHWMFsys.Enabled = false;
            else
                comboBoxHWCFanType.Items.Add("System Fan");

            if (0 == (u16FanSupport & F2ND))
                textBoxHWMFother.Enabled = false;
            else
                comboBoxHWCFanType.Items.Add("Other Fan");                
        }

        public void HWMInitializeTimer()
        {
            timerHWM.Tick += new EventHandler(HWMOnTick);
            timerHWM.Interval = timerIntervalHWM;
            timerHWM.Enabled = true;            
        }

        public void HWMDeInitializeTimer()
        {
            timerHWM.Enabled = false;
        }

        private unsafe void HWMOnTick(object s, EventArgs ea)
        {
            float[] volt = new float[10];
            float[] temp = new float[2];
            UInt16[] fan = new UInt16[3];
                           
            fixed(float* pfV = volt)                
            for (uint l = 0, i = 1; i < (1 << 10); i <<= 1)
            {                    
                if (0 != (i & u32VoltSupport))
                {
                    if (!SusiHWMGetVoltage(i, pfV+l, null))
                    {
                        MessageBox.Show("SusiHWMGetVoltage failed! " + "ErrorCode = " + SusiDllGetLastError().ToString());
                        return;
                    }                        
                }

                l++;
            }            

            textBoxHWMVcore.Text = volt[0].ToString();
            textBoxHWMV25.Text = volt[1].ToString();
            textBoxHWMV33.Text = volt[2].ToString();
            textBoxHWMV50.Text = volt[3].ToString();
            textBoxHWMV120.Text = volt[4].ToString();
            textBoxHWMVsb.Text = volt[5].ToString();
            textBoxHWMVbat.Text = volt[6].ToString();
            textBoxHWMVn50.Text = volt[7].ToString();
            textBoxHWMVn120.Text = volt[8].ToString();
            textBoxHWMVtt.Text = volt[9].ToString();

            fixed (float* pfT = temp)  
            for (ushort m = 0, j = 1; j < (1 << 2); j <<= 1)
            {
                if (0 != (j & u16TempSupport))
                {
                    if (!SusiHWMGetTemperature(j, pfT+m, null))
                    {
                        MessageBox.Show("SusiHWMGetTemperature failed! " + "ErrorCode = " + SusiDllGetLastError().ToString());
                        return;
                    }
                }

                m++;
            }

            textBoxHWMTcpu.Text = temp[0].ToString();
            textBoxHWMTsys.Text = temp[1].ToString();

            fixed (UInt16* pu16F = fan)      
            for (ushort n = 0, k = 1; k < (1 << 3); k <<= 1)
            {
                if (0 != (k & u16FanSupport))
                {
                    if (!SusiHWMGetFanSpeed(k, pu16F+n, null))
                    {
                        MessageBox.Show("SusiHWMGetFanSpeed failed! " + "ErrorCode = " + SusiDllGetLastError().ToString());
                        return;
                    }                     
                }
       
                n++;
            }

            textBoxHWMFcpu.Text = fan[0].ToString();
            textBoxHWMFsys.Text = fan[1].ToString();
            textBoxHWMFother.Text = fan[2].ToString();
        }
      
        private void buttonHWMMonitor_Click(object sender, EventArgs e)
        {            
            if (isHWMStart)
            {
                isHWMStart = false;
                HWMDeInitializeTimer();
                buttonHWMMonitor.Text = "Monitor";      
            }
            else
            {
                isHWMStart = true;
                HWMInitializeTimer();
                buttonHWMMonitor.Text = "Stop";                
            }
        }

        //===============================================================
        // Hardware Control       
        //
        private unsafe void buttonHWCSetFanSpeed_Click(object sender, EventArgs e)
        {
            int index = comboBoxHWCFanType.SelectedIndex;
            byte step = Convert.ToByte(textBoxHWCFanSpeed.Text); // 0-255

            UInt16 hwmtype;

            switch (index)
            {
                case 0:
                    hwmtype = FCPU;
                    break;
                case 1:
                    hwmtype = FSYS;
                    break;
                case 2:
                    hwmtype = F2ND;
                    break;
                case -1:
                    MessageBox.Show("Please select fan type");
                    return;
                default:
                    MessageBox.Show("Should never enter here");
                    return;
            }

            if (!SusiHWMSetFanSpeed(hwmtype, step, null))
            {
                MessageBox.Show("SusiHWMSetFanSpeed failed! " + "ErrorCode = " + SusiDllGetLastError().ToString());
                return;
            }
        }
    }
}